SystemOrganization addCategory: #'FSM-Base'!
SystemOrganization addCategory: #'FSM-Morphic'!
SystemOrganization addCategory: #'FSM-Tests'!

Morph subclass: #QHsmMorph
	instanceVariableNames: 'eventHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FSM-Morphic'!

!QHsmMorph class methodsFor: 'defaults' stamp: 'nk 8/13/2003 11:51'!
eventHandlerClass
	^QHsmMorphicEventHandler ! !

!QHsmMorph methodsFor: 'accessing' stamp: 'nk 10/19/2003 12:42'!
assuredEventHandler
	^eventHandler ifNil: [ self initializeFSM. eventHandler ]! !

!QHsmMorph methodsFor: 'debug and other' stamp: 'KR 5/10/2008 15:43'!
buildDebugMenu: aHand
	| menu |
	menu _ super buildDebugMenu: aHand.
	menu addLine.
	menu add: 'browse state handler class' translated target: self eventHandler selector: #browseHierarchy.
	menu add: 'view state hierarchy' translated target: self selector: #viewStateHierarchy.
	menu add: 'view log' translated target: self selector: #viewLog.
	menu add: 'clear log' translated target: self selector: #clearLog.
	menu addLine.
	menu add: 'start logging all but move and step events' translated target: self selector: #startLoggingAll.
	menu add: 'start logging move events' translated target: self selector: #startLoggingMoveEvents.
	menu add: 'start logging step events' translated target: self selector: #startLoggingStepEvents.
	menu add: 'start logging event...' translated target: self selector: #startLoggingSelectedEvent.
	menu addLine.
	"self loggingTypes isEmpty ifFalse: ["
		menu add: 'stop logging all events' translated target: self selector: #stopLoggingAll.
		menu add: 'stop logging event...' translated target: self selector: #stopLoggingSelectedEvent.
	"]."
	^menu! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/20/2003 20:58'!
clearLog
	self valueOfProperty: #logger ifPresentDo: [ :l | l clear ]
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:40'!
click: evt
! !

!QHsmMorph methodsFor: 'accessing' stamp: 'nk 9/29/2003 15:08'!
currentState
	^eventHandler ifNotNil: [ eventHandler currentState stateName ]
		ifNil: [ 'suspended' ]! !

!QHsmMorph methodsFor: 'event handling' stamp: 'tfel 8/2/2016 13:37'!
deferEvent: anEvent 
	"Defer anEvent for later processing."
	self log: #deferEvent items: {anEvent}.
	self assuredEventHandler deferEvent: anEvent.
	self
		startStepping: #processDeferredEvents
		at: Time millisecondClockValue
		arguments: #()
		stepTime: 10! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:40'!
doubleClickTimeout: evt
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:40'!
doubleClick: evt
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:37'!
dropFiles: anEvent
	"Handle a number of files dropped from the OS"
! !

!QHsmMorph methodsFor: 'accessing' stamp: 'nk 10/19/2003 12:34'!
eventHandler
	^eventHandler! !

!QHsmMorph methodsFor: 'accessing' stamp: 'nk 8/13/2003 17:27'!
eventHandler: anObjectOrNil
	eventHandler _ anObjectOrNil.! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:37'!
firstClickTimedOut: evt
	"Useful for double-click candidates who want to know whether or not the click is a single or double. In this case, ignore the #click: and wait for either this or #doubleClick:"

! !

!QHsmMorph methodsFor: 'TODO' stamp: 'tfel 8/2/2016 13:36'!
handleEvent: anEvent
	eventHandler ifNil: [ ^super handleEvent: anEvent ].
	eventHandler processDeferredEvents.
	eventHandler handleEvent: anEvent.
	eventHandler ifNotNil: [ eventHandler processDeferredEvents ].
	^ anEvent! !

!QHsmMorph methodsFor: 'TODO' stamp: 'tfel 8/2/2016 13:37'!
handleListenEvent: anEvent
	eventHandler processDeferredEvents.
	eventHandler handleEvent: anEvent.
	eventHandler processDeferredEvents.
	^ anEvent! !

!QHsmMorph methodsFor: 'event handling' stamp: 'nk 10/26/2003 08:00'!
handlesMouseOverDragging: evt
	^true! !

!QHsmMorph methodsFor: 'event handling' stamp: 'nk 10/26/2003 08:00'!
handlesMouseOver: evt
	^true! !

!QHsmMorph methodsFor: 'initialization' stamp: 'nk 10/19/2003 12:35'!
initializeFSM
	eventHandler ifNil: [
		eventHandler _ self class eventHandlerClass eventHandlerFor: self ].
	eventHandler init.
! !

!QHsmMorph methodsFor: 'initialization' stamp: 'nk 3/10/2004 07:51'!
intoWorld: aWorld
	"Ensure that we don't make an event handler if it's not wanted."
	aWorld ifNotNil: [ self inPartsBin ifFalse: [ self assuredEventHandler ]].
	^super intoWorld: aWorld.! !

!QHsmMorph methodsFor: 'accessing' stamp: 'nk 10/26/2003 10:58'!
isInState: aStateName
	self eventHandler ifNotNilDo: [ :eh | ^eh isIn: aStateName ].
	^false! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/19/2003 20:27'!
isLogging: type
	| types |
	types _ self valueOfProperty: #loggingTypes ifAbsent: [ ^false ].
	^types includes: type! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:37'!
keyDown: anEvent
	"Handle a key down event. The default response is to do nothing."! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:40'!
keyStroke: anEvent
	"Handle a keystroke event.  The default response is to let my eventHandler, if any, handle it."
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:37'!
keyUp: anEvent
	"Handle a key down event. The default response is to do nothing."! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/19/2003 20:57'!
logEvent: evt type: evtType handlingState: selector

	self log: (evtType == #step ifTrue: [ #stepEventHandled ] ifFalse: [ #eventHandled])
		items: { evt. evtType. selector }
! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/19/2003 20:26'!
logger
	^self valueOfProperty: #logger ifAbsentPut: [
		(Smalltalk at: #CircularTranscriptStream ifPresent: [ :cts | cts new: 200 ])
			ifNil: [ Transcript ] ]! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/19/2003 20:30'!
loggingTypes 
	^self valueOfProperty: #loggingTypes ifAbsent: [ #() ].
! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/19/2003 20:58'!
log: type items: anArray
	| log |
	(self isLogging: type) ifFalse: [ ^self ].
	log _ self logger.
	log nextPutAll: self externalName; nextPut: $(; print: self identityHash; nextPut: $); space; nextPutAll: type; space.
	anArray do: [ :item | log print: item ] separatedBy: [ log space ].
	log cr.! !

!QHsmMorph methodsFor: 'event handling' stamp: 'nk 8/13/2003 19:05'!
missedDeferredEvent: anEvent
	"anEvent, which was posted to my queue via #deferEvent:, had no handlers.
	The default action is to do nothing."! !

!QHsmMorph methodsFor: 'event handling' stamp: 'nk 10/19/2003 20:48'!
missedEvent: anEvent type: aSymbol
	"anEvent was not handled by either my state machine or its pluggable handlers.
	The default is to not handle the event.
	This should return true if the event is handled."

	(#(mouseMove mouseOver) includes: aSymbol)
		ifTrue: [ self log: #missedMoveEvent items: { self currentState. anEvent. aSymbol } ]
		ifFalse: [ self log: #missedEvent items: { self currentState. anEvent. aSymbol } ].

	^false! !

!QHsmMorph methodsFor: 'event handling' stamp: 'nk 10/19/2003 20:49'!
missedStepEvent
	"I got a step event, but it wasn't handled.
	The default response is to stop stepping; entry to a state that can handle step events should call #startStepping."
	self log: #missedStepEvent items: {}.
	self stopStepping! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:29'!
mouseDown: anEvent
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:40'!
mouseEnterDragging: evt
	"Handle a mouseEnterDragging event, meaning the mouse just entered my bounds with a button pressed or laden with submorphs.  The default response is to let my eventHandler, if any, handle it, or else to do nothing."
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:40'!
mouseEnter: evt
	"Handle a mouseEnter event, meaning the mouse just entered my bounds with no button pressed. The default response is to let my eventHandler, if any, handle it."
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 10/26/2003 09:09'!
mouseLeaveDragging: evt
	"Handle a mouseLeaveLaden event, meaning the mouse just left my bounds with a button pressed or laden with submorphs."
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 8/14/2003 18:40'!
mouseLeave: evt
	"Handle a mouseLeave event, meaning the mouse just left my bounds with no button pressed. The default response is to let my eventHandler, if any, handle it."
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 10/26/2003 09:09'!
mouseMove: evt
	"Handle a mouse move event."
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 10/26/2003 09:09'!
mouseStillDown: evt
	"Handle a mouse move event"
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 10/26/2003 09:09'!
mouseUp: evt
	"Handle a mouse up event."
! !

!QHsmMorph methodsFor: 'initialization' stamp: 'nk 10/19/2003 12:48'!
outOfWorld: aWorld
	eventHandler ifNotNil: [
		self processDeferredEvents.
		self stopStepping.
		self eventHandler handleEvent: #outOfWorld.
		eventHandler _ nil ].
	super outOfWorld: aWorld! !

!QHsmMorph methodsFor: 'printing' stamp: 'nk 8/14/2003 08:26'!
printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $[;
		nextPutAll: self currentState;
		nextPut: $]! !

!QHsmMorph methodsFor: 'stepping and presenter' stamp: 'nk 8/18/2003 10:43'!
processDeferredEvents
	"I may have some queued events. Process them."
	eventHandler processDeferredEvents.
	self stopSteppingSelector: #processDeferredEvents! !

!QHsmMorph methodsFor: 'TODO' stamp: 'tfel 8/2/2016 13:33'!
processEvent: anEvent using: defaultDispatcher
	| retval |
	retval _ anEvent.
	eventHandler ifNil: [ ^super processEvent: anEvent using: defaultDispatcher ].
	eventHandler processDeferredEvents.
	((self rejectsEvent: anEvent)
		or: [ (self fullContainsPoint: anEvent position) not
		or: [ (eventHandler handleMorphicEvent: anEvent eventOrType: anEvent) not ]])
			ifTrue: [ retval _ #rejected ].
	eventHandler processDeferredEvents.
	^retval! !

!QHsmMorph methodsFor: 'initialization' stamp: 'nk 10/18/2003 18:38'!
reinitializeFSM
	"Handy in debugging"
	eventHandler _ self class eventHandlerClass eventHandlerFor: self.
	self initializeFSM.! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/21/2003 13:54'!
releaseLogger
	self stopLoggingAll.
	self removeProperty: #logger.! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 10/18/2003 17:03'!
restoreSuspendedEventHandler
	| savedHandler |
	(savedHandler _ self valueOfProperty: #suspendedEventHandler) ifNotNil:
		[ eventHandler _ savedHandler.
		self removeProperty: #suspendedEventHandler.
		self trigger: #restoreSuspendedEventHandler.
		self processDeferredEvents ].
	submorphs do: [:m | m restoreSuspendedEventHandler]
! !

!QHsmMorph methodsFor: 'stepping and presenter' stamp: 'nk 8/16/2003 12:14'!
signal: anEvent afterMsec: timeoutInMsec
	eventHandler signal: anEvent afterMsec: timeoutInMsec! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 10/26/2003 09:08'!
startDrag: evt
	"This default implementation does nothing."
! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/23/2003 16:35'!
startLoggingAll
	"missedMoveEvent moveEventHandled missedStepEvent stepEventHandled"
	#(#eventHandled #missedEvent #alreadyHandledEvent #newInitialState #newState #pluggedEventHandled #action #deferEvent #debug )
		do: [:ea | self startLogging: ea]! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/23/2003 16:37'!
startLoggingMoveEvents
	"missedMoveEvent moveEventHandled missedStepEvent stepEventHandled"
	#(missedMoveEvent moveEventHandled )
		do: [:ea | self startLogging: ea]! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/20/2003 20:50'!
startLoggingSelectedEvent
	| event |
	event _ FillInTheBlank request: 'start logging which event?'.
	(event isNil or: [ event isEmpty ]) ifTrue: [ ^self ].
	self startLogging: event! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/23/2003 16:38'!
startLoggingStepEvents
	#(missedStepEvent stepEventHandled)
		do: [:ea | self startLogging: ea]! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/20/2003 20:55'!
startLogging: type
	| types |
	types _ self valueOfProperty: #loggingTypes ifAbsentPut: [ Set new ].
	types add: type! !

!QHsmMorph methodsFor: 'stepping and presenter' stamp: 'nk 3/10/2004 07:55'!
startStepping
	eventHandler ifNotNil: [ super startStepping ].! !

!QHsmMorph methodsFor: 'stepping and presenter' stamp: 'nk 3/10/2004 07:54'!
step
	"Notify my handler's state machine of the step event."
	eventHandler ifNil: [ ^self stopStepping ].
	(eventHandler handleEvent: #step eventOrType: #step) 
		ifFalse: [self missedStepEvent].
! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 10/26/2003 09:08'!
stopDrag: evt
	"This default implementation does nothing."
! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/19/2003 20:30'!
stopLoggingAll
	self removeProperty: #loggingTypes! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/23/2003 16:38'!
stopLoggingMoveEvents
	#(missedMoveEvent moveEventHandled )
		do: [:ea | self stopLogging: ea]! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/20/2003 20:54'!
stopLoggingSelectedEvent
	| event |
	event _ (SelectionMenu selections: (self loggingTypes asSortedCollection)) startUp.
	event ifNil: [ ^self ].
	self stopLogging: event! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/23/2003 16:38'!
stopLoggingStepEvents
	#(missedStepEvent stepEventHandled)
		do: [:ea | self stopLogging: ea]! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/19/2003 20:29'!
stopLogging: type
	| types |
	types _ self valueOfProperty: #loggingTypes ifAbsent: [ ^self ].
	types remove: type ifAbsent: []! !

!QHsmMorph methodsFor: 'event handling-overrides' stamp: 'nk 10/18/2003 17:13'!
suspendEventHandler
	"Put my event handler away for a while, perhaps because I'm being 
	put in a parts bin."
	self eventHandler
		ifNotNil: [ self processDeferredEvents.
			self stopStepping.
			self eventHandler handleEvent: #suspendEventHandler.
			self setProperty: #suspendedEventHandler toValue: self eventHandler.
			eventHandler _ nil].
	submorphs
		do: [:m | m suspendEventHandler]! !

!QHsmMorph methodsFor: 'event handling' stamp: 'nk 8/18/2003 10:50'!
trigger: type
	self deferEvent: (QEvent type: type arguments: #())! !

!QHsmMorph methodsFor: 'event handling' stamp: 'nk 8/18/2003 10:50'!
trigger: type withArguments: args
	self deferEvent: (QEvent type: type arguments: args)! !

!QHsmMorph methodsFor: 'event handling' stamp: 'nk 8/18/2003 10:50'!
trigger: type with: argument
	self deferEvent: (QEvent type: type arguments: { argument })! !

!QHsmMorph methodsFor: 'copying' stamp: 'nk 8/13/2003 17:15'!
updateReferencesUsing: aDictionary 
	"Update intra-morph references within a composite morph that 
	has been copied. For example, if a button refers to morph X in 
	the orginal 
	composite then the copy of that button in the new composite 
	should refer to 
	the copy of X in new composite, not the original X. This default 
	implementation updates the contents of any morph-bearing slot. 
	It may be 
	overridden to avoid this behavior if so desired."

	super updateReferencesUsing: aDictionary.
	eventHandler ifNotNilDo: [ :eh | eh updateReferencesUsing: aDictionary ]! !

!QHsmMorph methodsFor: 'logging' stamp: 'nk 10/19/2003 19:40'!
viewLog
	(self logger openAsMorphLabel: 'Log of ', self name) openInWorld! !

!QHsmMorph methodsFor: 'debug and other' stamp: 'nk 10/21/2003 11:04'!
viewStateHierarchy
	eventHandler ifNotNil: [ 
		StringHolder new
			acceptContents: eventHandler stateHierarchy;
			openLabel: 'State hierarchy of ', self name
	]! !

!QHsmMorph methodsFor: 'stepping and presenter' stamp: 'nk 8/13/2003 19:02'!
wantsSteps
	"Return true if I might want steps."
	^self isPartsDonor not! !

QHsmMorph subclass: #QHsmTestMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FSM-Tests'!

!QHsmTestMorph class methodsFor: 'as yet unclassified' stamp: 'nk 8/14/2003 08:24'!
eventHandlerClass
	^QHsmTestMorphEventHandler ! !

!QHsmTestMorph methodsFor: 'logging' stamp: 'nk 5/2/2004 13:58'!
logEvent: evt handlingState: selector 
	self logger print: self; space; print: evt; space; print: selector; cr; endEntry.

	! !

!QHsmTestMorph methodsFor: 'logging' stamp: 'nk 5/2/2004 13:58'!
logString: aString
	self logger nextPutAll: aString; cr; endEntry.! !

!QHsmTestMorph methodsFor: 'event handling' stamp: 'nk 5/2/2004 13:59'!
missedEvent: evt type: type
	(#(mouseOver mouseMove) includes: type) ifFalse: [
	self logger 
		nextPutAll: self currentState;
		nextPutAll: ' missed '; print: type; space; print: evt; cr; endEntry ].
	^super missedEvent: evt type: type! !

!String methodsFor: '*FSM-events' stamp: 'nk 8/8/2003 07:24'!
eventType
	^self! !

!MessageSend methodsFor: '*fsm-morphic' stamp: 'nk 8/13/2003 13:12'!
adaptToWorld: aWorld
	"If my recipient or arguments refer to a world or a hand, make them now refer
	to the corresponding items in the new world."
	receiver _ receiver adaptedToWorld: aWorld.
	arguments ifNotNil: [
		arguments _ arguments collect: [ :arg | arg adaptedToWorld: aWorld ]].! !

!Object methodsFor: '*FSM-events' stamp: 'nk 8/8/2003 07:14'!
eventType
	^self class name! !

!Object methodsFor: '*FSM-events' stamp: 'nk 8/8/2003 08:54'!
isQState
	^false! !

Object subclass: #QEvent
	instanceVariableNames: 'type arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FSM-Base'!

!QEvent class methodsFor: 'as yet unclassified' stamp: 'nk 8/15/2003 09:32'!
type: type
	^self new type: type; arguments: #()! !

!QEvent class methodsFor: 'as yet unclassified' stamp: 'nk 8/15/2003 09:32'!
type: type arguments: args
	^self new type: type; arguments: args! !

!QEvent methodsFor: 'accessing' stamp: 'nk 8/15/2003 09:32'!
arguments
	^arguments! !

!QEvent methodsFor: 'accessing' stamp: 'nk 8/15/2003 09:32'!
arguments: anObject
	arguments := anObject! !

!QEvent methodsFor: 'accessing' stamp: 'nk 8/15/2003 09:33'!
eventType
	^type! !

!QEvent methodsFor: 'printing' stamp: 'nk 8/15/2003 16:38'!
printOn: aStream
	aStream nextPutAll: 'QEvent['; print: type.
	arguments isEmptyOrNil ifFalse: [
		aStream nextPut: $(.
		arguments do: [ :arg | aStream print: arg ] separatedBy: [ aStream nextPut: $,].
		aStream nextPut: $).
	].
	aStream nextPut: $]! !

!QEvent methodsFor: 'accessing' stamp: 'nk 8/15/2003 09:32'!
type
	^type! !

!QEvent methodsFor: 'accessing' stamp: 'nk 8/15/2003 09:32'!
type: anObject
	type := anObject! !

Object subclass: #QHsm
	instanceVariableNames: 'myState mySource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FSM-Base'!

!QHsm commentStamp: 'nk 12/22/2003 15:40' prior: 0!
handlers may be named either
	handle<Event>In<State>:
or
	handle<State>:
and are passed each event.

They may return either:
	nil	--	event was handled in this state
	QState	--	handle in another (super) state

And internally they may call:
	newState:	--	change state to given state
	newInitialState:		-- only in response to an #init event, answer the next (sub) initial state.
			
Instance Variables
	myState -- the current state
	mySource -- the source of the current transition, if any (copied from myState at the beginning of an event dispatch).!

QHsm subclass: #QHsmMorphicEventHandler
	instanceVariableNames: 'morph handlers handled event firstClickDown eventQueue idleHistory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FSM-Morphic'!

!QHsmMorphicEventHandler commentStamp: 'nk 8/13/2003 13:14' prior: 0!
This is a unification of the QHsm and EventHandler classes, for use by QHsmMorphs.

morph		<Morph>	my target morph
handlers	<Dictionary<<Symbol>:<MessageSend>>	pluggable handlers!

!QHsmMorphicEventHandler class methodsFor: 'instance creation' stamp: 'nk 8/13/2003 12:22'!
eventHandlerFor: aMorph
	^(super initialState: #Initial) morph: aMorph; yourself! !

!QHsmMorphicEventHandler methodsFor: 'initialization' stamp: 'nk 8/13/2003 13:47'!
adaptToWorld: aWorld 
	"If any of my recipients refer to a world or a hand, make them now refer
	to the corresponding items in the new world."

	self handlersDo: [:h | h adaptToWorld: aWorld]! !

!QHsmMorphicEventHandler methodsFor: 'accessing' stamp: 'nk 8/13/2003 13:51'!
allRecipients
	"Answer a list, without duplication, of all the objects serving as recipients to any of the events I handle.
	Intended for debugging/documentation use only"
	| retval |
	retval _ Set new.
	self handlersDo: [:ea | retval add: ea receiver].
	^Array withAll: retval! !

!QHsmMorphicEventHandler methodsFor: 'menus' stamp: 'nk 10/23/2003 16:04'!
browseClass
	self  browseHierarchy! !

!QHsmMorphicEventHandler methodsFor: 'state handler actions' stamp: 'nk 12/17/2003 20:35'!
click: evt
	self log: #action items: { #click. evt }.

	morph click: evt.

	self handlerAt: #click ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph}.
		evt wasHandled: true ].! !

!QHsmMorphicEventHandler methodsFor: 'TODO' stamp: 'nk 8/13/2003 14:59'!
copyStateFrom: anEventHandlerOrNil
	"Not sure what to do here. There are some places where
		someMorph eventHandler: nil
	is called to suppress event handling."
	
	self halt.! !

!QHsmMorphicEventHandler methodsFor: 'events' stamp: 'nk 8/16/2003 12:07'!
deferEvent: anEvent
	"Defer anEvent for later processing."
	(eventQueue ifNil: [ eventQueue _ SharedQueue new ]) nextPut: anEvent.
! !

!QHsmMorphicEventHandler methodsFor: 'accessing-constants' stamp: 'nk 8/14/2003 13:59'!
doubleClickTime
	^HandMorph doubleClickTime! !

!QHsmMorphicEventHandler methodsFor: 'state handler guards' stamp: 'nk 10/19/2003 22:28'!
doubleClickTimedOut
	"Answer whether the current event happened outside of the double click timeout"

	^(event isMorphicEvent ifTrue: [ event timeStamp ] ifFalse: [ Time millisecondClockValue ]) - firstClickDown timeStamp > self doubleClickTime! !

!QHsmMorphicEventHandler methodsFor: 'state handler actions' stamp: 'nk 10/26/2003 08:51'!
doubleClickTimeout: evt
	self log: #action items: { #doubleClickTimeout. evt }.
	morph doubleClickTimeout: evt.

	self handlerAt: #doubleClickTimeout ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph}.
		evt wasHandled: true ].! !

!QHsmMorphicEventHandler methodsFor: 'state handler actions' stamp: 'nk 10/26/2003 08:51'!
doubleClick: evt
	self log: #action items: { #doubleClick. evt }.
	morph doubleClick: evt.
	
	self handlerAt: #doubleClick ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph}.
		evt wasHandled: true ].! !

!QHsmMorphicEventHandler methodsFor: 'accessing-constants' stamp: 'nk 8/14/2003 13:57'!
dragThreshold
	^10! !

!QHsmMorphicEventHandler methodsFor: 'accessing' stamp: 'nk 8/13/2003 18:32'!
event
	"Answer the event that I'm currently processing"
	^event! !

!QHsmMorphicEventHandler methodsFor: 'state handler guards' stamp: 'nk 8/14/2003 14:31'!
eventInsideMorphBounds
	^morph fullBounds containsPoint: event position! !

!QHsmMorphicEventHandler methodsFor: 'state handler guards' stamp: 'nk 8/14/2003 15:33'!
eventInsideMorphBounds: evt
	^evt isMorphicEvent and: [ morph fullBounds containsPoint: evt position ]! !

!QHsmMorphicEventHandler methodsFor: 'accessing' stamp: 'nk 8/13/2003 13:52'!
firstMouseSelector
	"Answer the selector corresponding to the first mouse-handling selector fielded.  Created in support of providing balloon-help for halo handles, triggered by the selector handled"

	#(#mouseDown #click #mouseMove #mouseStillDown #mouseUp #mouseEnter #mouseLeave #mouseEnterDragging #mouseLeaveDragging #doubleClick #startDrag) 
		do: [:sel | self handlerAt: sel ifPresent: [:h | ^h selector]].
	^nil! !

!QHsmMorphicEventHandler methodsFor: 'fixups' stamp: 'nk 8/13/2003 13:05'!
fixReversedValueMessages
	"There are no old instances of QHsmMorphicEventHandler!!"! !

!QHsmMorphicEventHandler methodsFor: 'initialization' stamp: 'nk 8/13/2003 13:48'!
forgetDispatchesTo: aSelector 
	"aSelector is no longer implemented by my corresponding Player, so don't call it any more"

	| forgotten |
	forgotten := Set new.
	self handlersKeysAndValuesDo: [:k :v | v selector == aSelector ifTrue: [forgotten add: k]].
	forgotten do: [:k | self handlers removeKey: k]! !

!QHsmMorphicEventHandler methodsFor: 'accessing' stamp: 'nk 10/18/2003 18:09'!
gestureRecipient
	^(self handlerAt: #gesture ifPresent: [:h | ^h receiver]) ifNil: [ self morph ].
! !

!QHsmMorphicEventHandler methodsFor: 'events-compatibility-TODO' stamp: 'nk 8/27/2003 09:03'!
gesture: aMorphicGestureEvent fromMorph: sourceMorph 
	"Pass the gesture event to the target morph"
"self halt."
	^self handleEvent: aMorphicGestureEvent eventOrType: #gesture! !

!QHsmMorphicEventHandler methodsFor: 'accessing' stamp: 'nk 8/14/2003 13:33'!
global
	"Answer my topmost state (whose parent is Top)"
	^self state: #Global! !

!QHsmMorphicEventHandler methodsFor: 'private' stamp: 'nk 10/19/2003 20:54'!
handleBasicEvent: anEvent eventOrType: anEventOrType 
	| lastEvent |
	handled := true.
	lastEvent _ event.
	event := anEvent.
	self dispatch: anEventOrType.
	event := lastEvent.
	self handlerAt: anEventOrType eventType
		ifPresent: 
			[:h | 
			h valueWithEnoughArguments: { 
						anEvent.
						morph}.
			self log: #pluggedEventHandled items: { anEvent. anEventOrType eventType }.
			^true].
	handled 
		ifFalse: [^morph missedEvent: anEvent type: anEventOrType eventType].
	^true! !

!QHsmMorphicEventHandler methodsFor: 'events-default handling' stamp: 'nk 8/14/2003 19:08'!
handleDropFiles: evt
	morph handleDropFiles: evt.

	self handlerAt: #dropFiles ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true.
	].! !

!QHsmMorphicEventHandler methodsFor: 'events-default handling' stamp: 'nk 8/14/2003 19:07'!
handleDropMorph: evt
	morph handleDropMorph: evt.

	self handlerAt: #dropMorph ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true.
	].! !

!QHsmMorphicEventHandler methodsFor: 'events' stamp: 'nk 8/14/2003 11:53'!
handleEvent: anEvent 
	^self handleEvent: anEvent eventOrType: anEvent eventType! !

!QHsmMorphicEventHandler methodsFor: 'private' stamp: 'nk 8/14/2003 11:53'!
handleEvent: anEvent eventOrType: aSymbol 
	^anEvent isMorphicEvent 
		ifTrue: [self handleMorphicEvent: anEvent eventOrType: aSymbol]
		ifFalse: [self handleBasicEvent: anEvent eventOrType: aSymbol]! !

!QHsmMorphicEventHandler methodsFor: 'events-default handling' stamp: 'nk 8/14/2003 19:09'!
handleKeyDown: evt
	morph handleKeyDown: evt.

	self handlerAt: #keyDown ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true.
	].! !

!QHsmMorphicEventHandler methodsFor: 'events-default handling' stamp: 'nk 8/14/2003 19:08'!
handleKeystroke: evt
	morph handleKeystroke: evt.

	self handlerAt: #keyStroke ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true.
	].! !

!QHsmMorphicEventHandler methodsFor: 'events-default handling' stamp: 'nk 8/14/2003 19:09'!
handleKeyUp: evt
	morph handleKeyUp: evt.

	self handlerAt: #keyUp ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true.
	].! !

!QHsmMorphicEventHandler methodsFor: 'private' stamp: 'nk 10/26/2003 09:26'!
handleMorphicEvent: anEvent eventOrType: anEventOrSymbol 
	"This is the main input to my event handling.
	anEvent is the Morphic event, translated into my coordinate system.
	anEventOrSymbol is either the same as anEvent, or is the assigned (pseudo) type which corresponds to the keys in my handlers."

	| wasHandled |
	anEvent isMouseOver ifTrue: [ anEvent hand noticeMouseOver: morph event: anEvent. ^true ].
	(#(mouseEnter mouseLeave) includes: anEvent eventType)
		ifFalse: [
			anEvent wasHandled ifTrue:  [
				self log: #alreadyHandledEvent items: { anEvent. anEventOrSymbol }.
				^true]].
	wasHandled := self handleBasicEvent: anEvent eventOrType: anEventOrSymbol eventType.
	anEvent wasHandled: wasHandled.
	^wasHandled! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 12/22/2003 15:26'!
handleMouseDownInFirstClickUp: evt 
	^self doubleClickTimedOut
		ifTrue: [ self doubleClickTimeout: evt. self returnToIdleHistory ]
		ifFalse: [ self newState: #SecondClickDown]! !

!QHsmMorphicEventHandler methodsFor: 'events-default handling' stamp: 'nk 8/14/2003 19:01'!
handleMouseDown: evt
	morph handleMouseDown: evt.

	self handlerAt: #mouseDown ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true.
	].! !

!QHsmMorphicEventHandler methodsFor: 'events-default handling' stamp: 'nk 8/14/2003 19:11'!
handleMouseEnter: evt
	morph handleMouseEnter: evt.

	self handlerAt: #mouseEnter ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true.
	].! !

!QHsmMorphicEventHandler methodsFor: 'events-default handling' stamp: 'nk 8/14/2003 19:11'!
handleMouseLeave: evt
	morph handleMouseLeave: evt.

	self handlerAt: #mouseLeave ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true.
	].! !

!QHsmMorphicEventHandler methodsFor: 'events-default handling' stamp: 'nk 8/14/2003 19:11'!
handleMouseMove: evt
	morph handleMouseMove: evt.

	self handlerAt: #mouseMove ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true.
	].! !

!QHsmMorphicEventHandler methodsFor: 'events-default handling' stamp: 'nk 8/14/2003 19:11'!
handleMouseOver: evt
	morph handleMouseOver: evt.

	self handlerAt: #mouseOver ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true.
	].! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 12/22/2003 15:26'!
handleMouseUpInFirstClickDown: evt 
	self click: event.
	^self doubleClickTimedOut
		ifTrue: [ self returnToIdleHistory ]
		ifFalse: [ self newState:  #FirstClickUp]! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 12/22/2003 15:26'!
handleMouseUpInSecondClickDown: evt 
	self doubleClickTimedOut
		ifFalse: [ self doubleClick: event ]
		ifTrue: [ self click: event ].
	^self returnToIdleHistory! !

!QHsmMorphicEventHandler methodsFor: 'events-default handling' stamp: 'nk 8/14/2003 19:05'!
handleMouseUp: evt
	morph handleMouseUp: evt.

	self handlerAt: #mouseUp ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true ].! !

!QHsmMorphicEventHandler methodsFor: 'private' stamp: 'nk 8/13/2003 13:49'!
handlerAt: aSymbol ifPresent: aBlock
	"Evaluate aBlock with my message send for aSymbol, if any"
	handlers ifNil: [ ^nil ].
	^handlers at: aSymbol ifPresent: [ :h | aBlock value: h ]! !

!QHsmMorphicEventHandler methodsFor: 'accessing' stamp: 'nk 8/13/2003 13:32'!
handlers
	^handlers ifNil: [handlers := IdentityDictionary new]! !

!QHsmMorphicEventHandler methodsFor: 'private' stamp: 'nk 8/13/2003 13:45'!
handlersDo: aBlock
	"Evaluate aBlock with all of my message sends"
	handlers ifNil: [ ^self ].
	handlers do: [ :ea | aBlock value: ea ]! !

!QHsmMorphicEventHandler methodsFor: 'private' stamp: 'nk 8/13/2003 13:46'!
handlersKeysAndValuesDo: aBlock
	"Evaluate aBlock with all of my message names and sends"
	handlers ifNil: [ ^self ].
	handlers keysAndValuesDo: [ :k :v | aBlock value: k value: v ]! !

!QHsmMorphicEventHandler methodsFor: 'testing-TODO' stamp: 'nk 8/13/2003 13:56'!
handlesClickOrDrag: evt 
	handlers ifNil: [ ^false ].
	^#(#click #doubleClick #startDrag) 
		anySatisfy: [:sym | handlers includesKey: sym]! !

!QHsmMorphicEventHandler methodsFor: 'testing-TODO' stamp: 'nk 6/12/2004 16:24'!
handlesGestureStart: evt
	"Does the associated morph want to handle gestures?"
	evt hand isGenieEnabled ifFalse: [ ^false ].

	self gestureRecipient ifNotNilDo:  [ :gestureRecipient |
		^(gestureRecipient gestureDictionaryStartEvent: evt) notNil ].
	^ (self gestureDictionaryStartEvent: event) notNil! !

!QHsmMorphicEventHandler methodsFor: 'testing-TODO' stamp: 'nk 8/13/2003 13:57'!
handlesKeyboard: evt
	self handlerAt: #keyStroke ifPresent: [ :h | ^true ].
	^false! !

!QHsmMorphicEventHandler methodsFor: 'testing-TODO' stamp: 'nk 8/13/2003 14:29'!
handlesMouseDown: evt
	#(mouseDown mouseUp mouseStillDown click doubleClick startDrag)
		do: [ :sel | self handlerAt: sel ifPresent: [ :h | ^true ]].
	self gestureRecipient ifNotNilDo: [ :gestureRecipient |
		^gestureRecipient allowsGestureStart: evt ].
	^false! !

!QHsmMorphicEventHandler methodsFor: 'testing-TODO' stamp: 'nk 10/26/2003 07:45'!
handlesMouseOverDragging: evt
	^true! !

!QHsmMorphicEventHandler methodsFor: 'testing-TODO' stamp: 'nk 10/25/2003 18:08'!
handlesMouseOver: evt
	^true! !

!QHsmMorphicEventHandler methodsFor: 'testing-TODO' stamp: 'nk 8/13/2003 13:59'!
handlesMouseStillDown: evt
	self handlerAt: #mouseStillDown ifPresent: [ :h | ^true ].
	^false! !

!QHsmMorphicEventHandler methodsFor: 'state handler actions' stamp: 'nk 8/13/2003 18:33'!
handleUnhandledEvent: anEvent
	"anEvent was not handled by the current state or any of its superstates.
	Remember that I didn't handle the event."
	handled _ false.
	^nil! !

!QHsmMorphicEventHandler methodsFor: 'state handler guards' stamp: 'nk 8/14/2003 13:57'!
isDrag
	"Answer whether the current event is further than the threshold from the first mouse down"

	^(event position - firstClickDown position) r > self dragThreshold! !

!QHsmMorphicEventHandler methodsFor: 'state handler guards' stamp: 'nk 8/14/2003 14:32'!
isMouseEvent: evt 
	^evt isMorphicEvent and: [evt isMouse]! !

!QHsmMorphicEventHandler methodsFor: 'events-compatibility-TODO' stamp: 'nk 8/14/2003 21:58'!
keyStroke: anEvent fromMorph: sourceMorph 
self halt.
! !

!QHsmMorphicEventHandler methodsFor: 'NCFSM compatibility' stamp: 'nk 8/16/2003 14:27'!
lastEventArguments
	^(event isKindOf: QEvent)
		ifTrue: [ event arguments ]
		ifFalse: [ { event } ]! !

!QHsmMorphicEventHandler methodsFor: 'logging' stamp: 'nk 10/23/2003 16:37'!
logEvent: evt type: evtType handlingState: selector 
	| logType eventOrType myStateName |
	logType _ evtType == #step
				ifTrue: [#stepEventHandled]
				ifFalse: [#eventHandled].
	(#(mouseMove mouseOver) includes: evtType) ifTrue: [ logType _ #moveEventHandled ].
	myStateName _ myState stateName.
	eventOrType _ evt == evtType
				ifTrue: [event]
				ifFalse: [evtType].
	myStateName ~~ selector
		ifTrue: [self log: logType items: {evt. eventOrType. selector. '[' , myStateName , ']'}]
		ifFalse: [self log: logType items: {evt. eventOrType. selector}]! !

!QHsmMorphicEventHandler methodsFor: 'logging' stamp: 'nk 10/19/2003 20:41'!
log: type items: items
	morph log: type items: items! !

!QHsmMorphicEventHandler methodsFor: 'accessing' stamp: 'nk 5/1/2004 08:31'!
methodRefList
	"Return a MethodReference for each message I can send."
	self shouldBeImplemented! !

!QHsmMorphicEventHandler methodsFor: 'accessing' stamp: 'nk 8/13/2003 11:52'!
morph
	^morph! !

!QHsmMorphicEventHandler methodsFor: 'private' stamp: 'nk 8/13/2003 14:40'!
morphDo: aBlock
	"Evaluate aBlock with my morph.
	Intended for future use to suppress callbacks for event response testing."
	^aBlock value: morph! !

!QHsmMorphicEventHandler methodsFor: 'accessing' stamp: 'nk 8/13/2003 11:52'!
morph: anObject
	morph := anObject! !

!QHsmMorphicEventHandler methodsFor: 'events-compatibility-TODO' stamp: 'nk 8/14/2003 21:58'!
mouseDown: anEvent fromMorph: sourceMorph 
	"Take double-clicks into account."
self halt.
! !

!QHsmMorphicEventHandler methodsFor: 'events-compatibility-TODO' stamp: 'nk 8/14/2003 21:57'!
mouseEnterDragging: anEvent fromMorph: sourceMorph 
self halt.
! !

!QHsmMorphicEventHandler methodsFor: 'events-compatibility-TODO' stamp: 'nk 8/14/2003 21:57'!
mouseEnter: anEvent fromMorph: sourceMorph 
self halt.
! !

!QHsmMorphicEventHandler methodsFor: 'events-compatibility-TODO' stamp: 'nk 8/14/2003 21:57'!
mouseLeaveDragging: anEvent fromMorph: sourceMorph 
self halt.
! !

!QHsmMorphicEventHandler methodsFor: 'events-compatibility-TODO' stamp: 'nk 8/14/2003 21:57'!
mouseLeave: anEvent fromMorph: sourceMorph 
self halt.
! !

!QHsmMorphicEventHandler methodsFor: 'events-compatibility-TODO' stamp: 'nk 8/14/2003 21:57'!
mouseMove: anEvent fromMorph: sourceMorph 
self halt.
! !

!QHsmMorphicEventHandler methodsFor: 'events-compatibility-TODO' stamp: 'nk 8/14/2003 21:57'!
mouseStillDown: anEvent fromMorph: sourceMorph 
self halt.
! !

!QHsmMorphicEventHandler methodsFor: 'events-compatibility-TODO' stamp: 'nk 8/14/2003 21:57'!
mouseUp: anEvent fromMorph: sourceMorph 
self halt.
! !

!QHsmMorphicEventHandler methodsFor: 'state handler actions' stamp: 'nk 10/19/2003 21:40'!
newInitialState: aState
	self log: #newInitialState items: { myState stateName. aState }.
	^super newInitialState: aState.
! !

!QHsmMorphicEventHandler methodsFor: 'state handler actions' stamp: 'nk 5/5/2004 12:56'!
newState: aState
	mySource ~= myState
		ifTrue: [ self log: #newState items: { myState stateName. mySource ifNotNilDo: [ :s | s stateName ]. aState } ]
		ifFalse: [ self log: #newState items: { myState stateName. aState } ].
	^super newState: aState.
! !

!QHsmMorphicEventHandler methodsFor: 'objects from disk' stamp: 'nk 9/15/2003 18:32'!
objectForDataStream: refStrm
	refStrm replace: event with: nil.
	refStrm replace: eventQueue with: nil.
	refStrm replace: firstClickDown with: nil.
	^self! !

!QHsmMorphicEventHandler methodsFor: 'initialization' stamp: 'nk 8/13/2003 13:54'!
on: eventName send: selector to: recipient 
	"if selector and recipient are both nil, remove the handler"

	recipient ifNil: 
			[ handlers ifNotNil: [ handlers removeKey: eventName ifAbsent: [] ].
			^self].
	self handlers at: eventName
		put: (MessageSend receiver: recipient selector: selector)! !

!QHsmMorphicEventHandler methodsFor: 'initialization' stamp: 'nk 8/13/2003 13:32'!
on: eventName send: selector to: recipient withValue: value 
	"NOTE: selector must take 3 arguments, as follows:
		value
		event
		sourceMorph"

	self handlers at: eventName
		put: (MessageSend 
				receiver: recipient
				selector: selector
				argument: value)! !

!QHsmMorphicEventHandler methodsFor: 'printing' stamp: 'nk 8/13/2003 13:56'!
printOn: aStream 
	super printOn: aStream.
	handlers isEmptyOrNil 
		ifFalse: 
			[aStream nextPut: $[.
			handlers keysAndValuesDo: 
					[:k :v | 
					aStream
						nextPutAll: k;
						nextPut: $=;
						print: v;
						nextPut: $;].
			aStream
				skip: -1;
				nextPut: $]]! !

!QHsmMorphicEventHandler methodsFor: 'events' stamp: 'nk 8/16/2003 12:06'!
processDeferredEvents
	"I may have some queued events. Process them."
	eventQueue ifNotNil:  [| evt |
			[(evt := eventQueue nextOrNil) notNil] whileTrue: 
				[(self handleEvent: evt) ifFalse: [morph missedDeferredEvent: evt]]].
! !

!QHsmMorphicEventHandler methodsFor: 'fixups' stamp: 'nk 8/13/2003 13:05'!
replaceSendsIn: array1 with: array2
	"Replace all the sends that occur in array1 with those in array2. Used for fixing old event handlers in files."
! !

!QHsmMorphicEventHandler methodsFor: 'state handler actions' stamp: 'nk 12/22/2003 15:47'!
returnToIdleHistory
	"Idle history has been saved; transition back to it (and clear it)"
	| history |
	history _ idleHistory ifNil: [ #Idle].
	idleHistory _ nil.
	mySource ~= myState
		ifTrue: [self log: #newState items: {myState stateName. mySource stateName. history. 'idle history' }]
		ifFalse: [self log: #newState items: {myState stateName. history. 'idle history'}].
	^self newDynamicState: history.
! !

!QHsmMorphicEventHandler methodsFor: 'state handler actions' stamp: 'nk 12/22/2003 15:23'!
saveIdleHistory
	idleHistory _ self currentState.! !

!QHsmMorphicEventHandler methodsFor: 'events' stamp: 'nk 8/16/2003 12:13'!
signal: anEvent afterMsec: timeoutInMsec
	"Schedule a morphic alarm to fire after timeInMsec milliseconds that will queue an event on my morph's event queue, to be processed during its step method."
	morph world ifNotNilDo: [ :w |
		w addAlarm: #deferEvent:
			withArguments: { anEvent }
			for: self
			at: Time millisecondClockValue + timeoutInMsec ]! !

!QHsmMorphicEventHandler methodsFor: 'state handler actions' stamp: 'nk 1/17/2004 10:53'!
sourceState
	^mySource stateName! !

!QHsmMorphicEventHandler methodsFor: 'state handler actions' stamp: 'nk 10/26/2003 08:50'!
startDrag: evt
	self log: #action items: { #startDrag. evt }.

	morph startDrag: evt.

	self handlerAt: #startDrag ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true ].! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 12/22/2003 15:27'!
stateDragging: evt 
	^evt caseOf: { 
				[#entry] -> 
						[self startDrag: event.
						nil].
				[#exit] -> 
						[self stopDrag: event.
						nil].
				[#mouseUp] -> [ self returnToIdleHistory ]}
		otherwise: [self global]! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:54'!
stateFirstClickDown: evt 
	^self state: #WaitingForDoubleClickWithMouseDown! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:54'!
stateFirstClickUp: evt 
	^self state: #WaitingForDoubleClick! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 8/16/2003 12:43'!
stateGlobal: evt 
	^evt == #init 
		ifTrue: [self newInitialState: #Idle]
		ifFalse: [self top]! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 12/22/2003 15:24'!
stateIdle: evt 
	evt == #mouseDown ifTrue: [
		event blueButtonPressed ifTrue: [ morph blueButtonDown: event. ^nil ].
		^self newState: #WaitingForDoubleClick ].
	"Save history for return from WaitingForDoubleClick"
	evt == #exit ifTrue: [ self saveIdleHistory. ^nil ].
	^self global! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:54'!
stateInitial: evtOrNil 
	^self newInitialState: #Global! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:54'!
stateSecondClickDown: evt 
	^self state: #WaitingForDoubleClickWithMouseDown! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 12/22/2003 15:27'!
stateWaitingForDoubleClickWithMouseDown: evt
	evt == #init ifTrue: [^self newInitialState: #FirstClickDown].

	(#(mouseDown mouseUp mouseMove) includes: evt)
		ifFalse: [^self state: #WaitingForDoubleClick].

	evt == #mouseUp ifTrue: [^ self returnToIdleHistory ].
	self isDrag 
		ifTrue: 
			[self doubleClickTimedOut ifFalse: [self doubleClickTimeout: event].
			^self newState: #Dragging].
	(self doubleClickTimedOut 
		and: [self currentState ~= #WaitingForDoubleClickWithMouseDown]) 
			ifTrue: 
				[self doubleClickTimeout: event.
				^self newState: #WaitingForDoubleClickWithMouseDown].
	^self state: #WaitingForDoubleClick! !

!QHsmMorphicEventHandler methodsFor: 'state handlers' stamp: 'nk 12/22/2003 15:27'!
stateWaitingForDoubleClick: evt 
	^evt caseOf: { 
				[#entry] -> 
						[firstClickDown := (event copy setHand: nil).
						morph startStepping.
						nil].
				[#init] -> [self newInitialState: #WaitingForDoubleClickWithMouseDown ].
				[#step] -> 
						[self doubleClickTimedOut ifTrue: 
								[ self returnToIdleHistory ]].
				[#exit] -> 
						[morph stopStepping.
						self doubleClickTimedOut 
							ifTrue: 
								[self doubleClickTimeout: event.
								nil]].
				[#mouseLeave] -> 
						[self eventInsideMorphBounds 
							ifTrue: [ self returnToIdleHistory ]
							ifFalse: [self global]]}
		otherwise: [self global]! !

!QHsmMorphicEventHandler methodsFor: 'state handler actions' stamp: 'nk 10/26/2003 08:50'!
stopDrag: evt
	self log: #action items: { #stopDrag. evt }.
	
	morph stopDrag: evt.

	"This is an addition"
	self handlerAt: #stopDrag ifPresent: [ :h | 
		h valueWithEnoughArguments: {  evt. morph }.
		evt wasHandled: true ].! !

!QHsmMorphicEventHandler methodsFor: 'NCFSM compatibility' stamp: 'nk 8/16/2003 12:18'!
trigger: type
	self deferEvent: (QEvent type: type arguments: #())! !

!QHsmMorphicEventHandler methodsFor: 'NCFSM compatibility' stamp: 'nk 8/16/2003 12:19'!
trigger: type with: argument
	self deferEvent: (QEvent type: type arguments: { argument })! !

!QHsmMorphicEventHandler methodsFor: 'copying' stamp: 'nk 8/13/2003 17:23'!
updateReferencesUsing: aDictionary 
	"Update intra-morph references within a composite morph that 
	has been copied. For example, if a button refers to morph X in 
	the orginal 
	composite then the copy of that button in the new composite 
	should refer to 
	the copy of X in new composite, not the original X. This default 
	implementation updates the contents of any morph-bearing slot. 
	It may be 
	overridden to avoid this behavior if so desired."

	self handlersKeysAndValuesDo: [ :key :ms |
		aDictionary at: ms receiver ifPresent: [ :m | ms receiver: m ].
		ms arguments: (ms arguments ifNotNilDo: [ :args |
			args collect: [ :arg | aDictionary at: arg ifAbsent: [ arg ]]]).
	]! !

!QHsmMorphicEventHandler methodsFor: 'copying' stamp: 'nk 8/13/2003 12:49'!
veryDeepFixupWith: deepCopier 
	"ALL inst vars were weakly copied. If they were in the tree being 
	copied, fix them up, otherwise point to the originals!!"
	| old |
	super veryDeepFixupWith: deepCopier.
	1 to: self class instSize do: [ :ii | 
			old _ self instVarAt: ii.
			self
				instVarAt: ii
				put: (deepCopier references
						at: old
						ifAbsent: [old])]! !

!QHsmMorphicEventHandler methodsFor: 'NCFSM compatibility' stamp: 'nk 8/15/2003 09:42'!
willRespondToAnyOf: someEventSymbols
	"Answer whether I will respond to any of someEventSymbols in my current state"
	self halt.
	^true! !

!QHsmMorphicEventHandler methodsFor: 'NCFSM compatibility' stamp: 'nk 8/15/2003 09:41'!
willRespondTo: anEventSymbol
	self halt.
	^true! !

QHsmMorphicEventHandler subclass: #QHsmTestMorphEventHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FSM-Tests'!

!QHsmTestMorphEventHandler methodsFor: 'state handler actions' stamp: 'nk 5/2/2004 13:59'!
click: evt
	morph logger nextPutAll: 'click'; cr; endEntry.
	^super click: evt! !

!QHsmTestMorphEventHandler methodsFor: 'state handler actions' stamp: 'nk 5/2/2004 13:59'!
doubleClickTimeout: evt
	morph logger  nextPutAll: 'doubleClickTimeout'; cr; endEntry.
	^super doubleClickTimeout: evt! !

!QHsmTestMorphEventHandler methodsFor: 'state handler actions' stamp: 'nk 5/2/2004 13:59'!
doubleClick: evt
	morph logger  nextPutAll: 'doubleClick'; cr; endEntry.
	^super doubleClick: evt! !

!QHsmTestMorphEventHandler methodsFor: 'events-default handling' stamp: 'nk 5/2/2004 13:59'!
handleKeystroke: evt
	morph logger  nextPutAll: 'keyStroke'; cr; endEntry.
	^super handleKeystroke: evt! !

!QHsmTestMorphEventHandler methodsFor: 'events-default handling' stamp: 'nk 5/2/2004 13:59'!
handleMouseDown: evt
	morph logger  nextPutAll: 'mouseDown'; cr; endEntry.
	^super handleMouseDown: evt! !

!QHsmTestMorphEventHandler methodsFor: 'events-default handling' stamp: 'nk 5/2/2004 13:59'!
handleMouseUp: evt
	morph logger  nextPutAll: 'mouseUp'; cr; endEntry.
	^super handleMouseUp: evt! !

!QHsmTestMorphEventHandler methodsFor: 'state handler actions' stamp: 'nk 8/14/2003 22:05'!
handleUnhandledEvent: anEvent
	"anEvent was not handled by the current state or any of its superstates.
	Remember that I didn't handle the event."
	handled _ false.
	event isMorphicEvent ifTrue: [
		event wasHandled ifFalse: [ event sentTo: self ]].
	^nil! !

!QHsmTestMorphEventHandler methodsFor: 'logging' stamp: 'nk 8/14/2003 15:52'!
logEvent: evt handlingState: selector 
! !

!QHsmTestMorphEventHandler methodsFor: 'state handler actions' stamp: 'nk 5/2/2004 14:00'!
startDrag: evt
	morph logger  nextPutAll: 'startDrag'; cr; endEntry.
	^super startDrag: evt! !

!QHsmTestMorphEventHandler methodsFor: 'state handler actions' stamp: 'nk 5/2/2004 14:00'!
stopDrag: evt
	morph logger  nextPutAll: 'stopDrag'; cr; endEntry.
	^super stopDrag: evt! !

QHsm subclass: #QHsmTestSM
	instanceVariableNames: 'events transitions myFoo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FSM-Tests'!

!QHsmTestSM commentStamp: 'nk 8/12/2003 13:57' prior: 0!
void initial(QEvent const *e);              // initial pseudostate
   QSTATE s0(QEvent const *e);                       // state-handler
      QSTATE s1(QEvent const *e);                    // state-handler
         QSTATE s11(QEvent const *e);                // state-handler 
      QSTATE s2(QEvent const *e);                    // state-handler
         QSTATE s21(QEvent const *e);                // state-handler
            QSTATE s211(QEvent const *e);            // state-handler
!

!QHsmTestSM class methodsFor: 'as yet unclassified' stamp: 'nk 8/12/2003 11:40'!
new
	^super initialState: 'Initial'! !

!QHsmTestSM methodsFor: 'running' stamp: 'nk 2/17/2004 22:02'!
dispatchEvent: anEvent selector: selector
	| type handlerState  |
	type _ anEvent eventType.
	type ~~ #empty ifTrue: [ events addLast: ((anEvent ifNotNil: [ type ]) -> selector) ].
	handlerState _ super dispatchEvent: anEvent selector: selector.
	^handlerState.! !

!QHsmTestSM methodsFor: 'running' stamp: 'nk 2/17/2004 21:56'!
dispatch: anEvent
	| originalState handlerState  |
	originalState _ myState.
	Transcript nextPutAll: 'State: '; print: myState stateName;
		nextPutAll: ' Event: '; print: anEvent; cr.
	handlerState _ super dispatch: anEvent.
	Transcript nextPutAll: 'Handler: '; print: handlerState.
	myState ~= originalState ifTrue: [ Transcript nextPutAll: ' NewState: '; print: myState ].
	Transcript cr; endEntry.
	transitions addLast: { originalState. anEvent. myState }.
	^handlerState.! !

!QHsmTestSM methodsFor: 'accessing' stamp: 'nk 8/7/2003 16:51'!
events
	^events! !

!QHsmTestSM methodsFor: 'state handlers' stamp: 'nk 8/12/2003 14:06'!
handleUnhandledEvent: anEvent
	self error: 'unhandled'.
	^nil! !

!QHsmTestSM methodsFor: 'initialization' stamp: 'nk 8/12/2003 15:39'!
initialize
	super initialize.
	events _ OrderedCollection new.
	transitions _ OrderedCollection new.! !

!QHsmTestSM methodsFor: 'running' stamp: 'nk 2/17/2004 21:59'!
logEvent: anEvent type: eventType handlingState: selector 
	anEvent ~= #empty 
		ifTrue: 
			[ Transcript
				print: myState;
				space;
				print: anEvent;
				space;
				print: selector;
				cr]! !

!QHsmTestSM methodsFor: 'accessing' stamp: 'nk 8/12/2003 16:09'!
myFoo
	^myFoo! !

!QHsmTestSM methodsFor: 'accessing' stamp: 'nk 8/12/2003 16:09'!
myFoo: aBoolean
	myFoo _ aBoolean! !

!QHsmTestSM methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:54'!
stateInitial: anEvent 
	myFoo := false.
	self newInitialState: 's0'.
	^nil! !

!QHsmTestSM methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:58'!
stateS0: anEvent 
	^anEvent eventType caseOf: { 
				[#entry] -> [nil].
				[#exit] -> [nil].
				[#init] -> 
						[self newInitialState: 's1'.
						nil].
				['E'] -> 
						[self newState: 's211'.
						nil]}
		otherwise: [self top]! !

!QHsmTestSM methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:59'!
stateS11: anEvent 
	anEvent eventType caseOf: { 
				[#entry] -> [^nil].
				[#exit] -> [^nil].
				['G'] -> 
						[self newState: 's211'.
						^nil].
				['H'] -> 
						[myFoo 
							ifTrue: 
								[myFoo := false.
								^nil]]}
		otherwise: [].
	^self state: 's1'! !

!QHsmTestSM methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:59'!
stateS1: anEvent 
	^anEvent eventType caseOf: { 
				[#entry] -> [nil].
				[#exit] -> [nil].
				[#init] -> 
						[self newInitialState: 's11'.
						nil].
				['A'] -> 
						[self newState: 's1'.
						nil].
				['B'] -> 
						[self newState: 's11'.
						nil].
				['C'] -> 
						[self newState: 's2'.
						nil].
				['D'] -> 
						[self newState: 's0'.
						nil].
				['F'] -> 
						[self newState: 's211'.
						nil]}
		otherwise: [self state: 's0']! !

!QHsmTestSM methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:59'!
stateS211: anEvent 
	anEvent eventType caseOf: { 
				[#entry] -> [^nil].
				[#exit] -> [^nil].
				['D'] -> 
						[self newState: 's21'.
						^nil].
				['G'] -> 
						[self newState: 's0'.
						^nil]}
		otherwise: [].
	^self state: 's21'! !

!QHsmTestSM methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:58'!
stateS21: anEvent 
	anEvent eventType caseOf: { 
				[#entry] -> [^nil].
				[#exit] -> [^nil].
				[#init] -> 
						[self newInitialState: 's211'.
						^nil].
				['B'] -> 
						[self newState: 's211'.
						^nil].
				['H'] -> 
						[myFoo 
							ifFalse: 
								[myFoo := true.
								self newState: 's21'.
								^nil]]}
		otherwise: [].
	^self state: 's2'! !

!QHsmTestSM methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:59'!
stateS2: anEvent 
	^anEvent eventType caseOf: { 
				[#entry] -> [nil].
				[#exit] -> [nil].
				[#init] -> 
						[self newInitialState: 's21'.
						nil].
				['C'] -> 
						[self newState: 's1'.
						nil].
				['F'] -> 
						[self newState: 's11'.
						nil]}
		otherwise: [self state: 's0']! !

!QHsmTestSM methodsFor: 'accessing' stamp: 'nk 8/12/2003 14:48'!
transitions
	^transitions! !

!QHsmTestSM methodsFor: 'running' stamp: 'nk 8/15/2003 09:36'!
trigger: type withArguments: args
	^self dispatch: (QEvent type: type arguments: args)! !

!QHsmTestSM methodsFor: 'running' stamp: 'nk 8/15/2003 09:36'!
trigger: type with: argument
	^self dispatch: (QEvent type: type arguments: { argument })! !

!QHsm class methodsFor: 'instance creation' stamp: 'nk 1/8/2004 16:08'!
initialState: aStateName
	^(super new) initialState: aStateName; yourself! !

!QHsm class methodsFor: 'instance creation' stamp: 'nk 8/8/2003 08:32'!
new
	^self error: 'QHsm instances must be created with #initialState:'! !

!QHsm class methodsFor: 'events' stamp: 'nk 8/8/2003 08:06'!
reservedEventTypes
	"These events are sent to state handlers for special purposes"
	^{
		#empty.	"Return superstate (should never be handled)"
		#init.		"Do initial transition"
		#entry.	"Do state entry"
		#exit.		"Do state exit"
	}! !

!QHsm methodsFor: 'error handling' stamp: 'nk 8/18/2004 18:14'!
assert: aBlock descriptionBlock: descriptionBlock
	"Throw an assertion error if aBlock does not evaluate to true."

	aBlock value ifFalse: [AssertionFailure signal: descriptionBlock value asString ]! !

!QHsm methodsFor: 'error handling' stamp: 'nk 8/18/2004 18:14'!
assert: aBlock description: aString
	"Throw an assertion error if aBlock does not evaluates to true."

	aBlock value ifFalse: [AssertionFailure signal: aString ]! !

!QHsm methodsFor: 'accessing' stamp: 'nk 8/11/2003 22:02'!
currentState
	^myState! !

!QHsm methodsFor: 'private' stamp: 'nk 2/17/2004 21:12'!
dispatchEvent: anEvent selector: selector
	^self perform: selector withArguments: { anEvent }.! !

!QHsm methodsFor: 'running' stamp: 'nk 1/15/2004 11:01'!
dispatch: anEvent 
	"Traverse the state hierarchy starting from the currently active state.
	Advance up the hierarchy from substates to superstates until a state handler handles the event.
	Use an instVar to provide access to the transition: method.
	Answers the state that handled the event."

	| lastState |
	mySource := myState.
	[mySource notNil] whileTrue: 
			[lastState := mySource.
			mySource := mySource trigger: anEvent.
			self assert: [mySource isNil or: [lastState superstate = mySource]]
				descriptionBlock: [ 'can''t go from' , lastState asString , ' to ' 
						, mySource asString]].
	(anEvent eventType ~~ #empty and: [lastState ~= #Top]) 
		ifTrue: 
			[self 
				logEvent: anEvent
				type: anEvent eventType
				handlingState: lastState stateName].
	^lastState! !

!QHsm methodsFor: 'private' stamp: 'nk 10/25/2003 16:48'!
enter: target via: entry
	"This is the common tail of #transitionDynamicallyTo:.
	Now we're in the LCA of mySource and target"
	"inLCA:"
	| sub |
	entry reverseDo: [ :s | s enter ].	"retrace the entry path in reverse order"
	myState _ sub _ target.
	[ (sub init) isNil ] whileTrue: [
		self assert: [ sub = myState superstate ] description: 'initial transition must go one level deep'.
		sub _ myState.
		sub enter.		"enter target"
	]! !

!QHsm methodsFor: 'private' stamp: 'nk 8/12/2003 13:06'!
fullSelectorFor: type in: stateName
	| fullSelector |
	fullSelector := String new: stateName size + type size + 9.	"handleTypeInSelector:"
	fullSelector
		replaceFrom: 1
			to: 6
			with: 'handle'
			startingAt: 1;
		at: 7 put: type first asUppercase;
		replaceFrom: 8
			to: 6 + type size
			with: type
			startingAt: 2;
		replaceFrom: 7 + type size
			to: 8 + type size
			with: 'In'
			startingAt: 1;
		replaceFrom: 9 + type size
			to: 8 + type size + stateName size
			with: stateName
			startingAt: 1;
		at: fullSelector size put: $:.
	^fullSelector! !

!QHsm methodsFor: 'logging' stamp: 'nk 9/12/2003 17:46'!
handleUnhandledEvent: anEvent
	"anEvent was not handled by the current state or any of its superstates."
	^nil! !

!QHsm methodsFor: 'reflection' stamp: 'nk 8/14/2003 22:26'!
hierarchyFrom: superstates andEvents: events into: aStream startingAt: parent level: level 
	aStream
		tab: level;
		nextPutAll: parent.
	events at: parent ifPresent: [ :evs |
		aStream space.
		evs do: [ :e | aStream nextPut: $(; nextPutAll: e; nextPut: $) ] separatedBy: [ aStream space ].
	].
	aStream cr.
	superstates keysAndValuesDo: 
			[:k :v | 
			v = parent 
				ifTrue: 
					[self 
						hierarchyFrom: superstates
						andEvents: events
						into: aStream
						startingAt: k
						level: level + 1]]! !

!QHsm methodsFor: 'initialization' stamp: 'nk 8/12/2003 14:03'!
init
	^self init: nil! !

!QHsm methodsFor: 'initialization' stamp: 'nk 8/8/2003 09:47'!
initialize
	"Do whatever setup is required. But do not change states."

	! !

!QHsm methodsFor: 'initialization' stamp: 'nk 8/12/2003 11:32'!
initialState: aStateName
	"Like in QHsm::QHsm()"
	myState _ self top.
	mySource _ self state: aStateName.! !

!QHsm methodsFor: 'initialization' stamp: 'nk 8/12/2003 13:00'!
init: anEventOrNil
	"Trigger the initial transition and recursively enter the submachine of the top state.
	Must be called only once for a given QHsm before dispatching any events to it."
	| s |
	self assert: [ myState stateName = #Top and: [ mySource notNil ] ].
	s _ myState.	"save top in temp"
	mySource trigger: anEventOrNil.		"topmost initial transition"
	self assert: [ s = myState superstate ].	"verify that we only went one level deep"
	s _ myState.
	s enter.
	[ s init isNil ] whileTrue: [ 		"while init is handled"
		self assert: [ s = myState superstate ].	"verify that we only went one level deep"
		s _ myState.
		s enter.						"and enter substate"
	]! !

!QHsm methodsFor: 'testing' stamp: 'nk 8/12/2003 13:54'!
isIn: aStateOrName
	"Being in a given state means also being in all the substates of that state."
	| state |
	state _ myState.
	[ state notNil ] whileTrue: [
		state = aStateOrName ifTrue: [ ^true ].
		state _ state superstate ].
	^false! !

!QHsm methodsFor: 'logging' stamp: 'nk 10/18/2003 17:25'!
logEvent: anEvent type: eventType handlingState: selector 
	"anEvent is about to be dispatched to the given handler"

	! !

!QHsm methodsFor: 'state handler actions' stamp: 'nk 8/13/2003 14:44'!
newDynamicState: aStateName
	"Drive state handlers to accomplish a dynamic state transition.
	A dynamic state transition is one in which the source and target of the transition may change at run time.
	Answers nil for convenience: you can say:
		^self newDynamicState: 'whatever'
	in a handler method.
	See also #newState:"
	"Q_TRAN_DYN()"

	self transitionDynamicallyTo: (self state: aStateName).
	^nil! !

!QHsm methodsFor: 'state handler actions' stamp: 'nk 8/13/2003 14:43'!
newInitialState: aStateOrName
	"to be used by handlers only in response to the #init event.
	Sets myState to the new state.
	Answers nil for convenience: you can say:
		^self newInitialState: 'whatever'
	in a handler method.
	Q_INIT()"

	myState _ self state: aStateOrName.
	^nil! !

!QHsm methodsFor: 'state handler actions' stamp: 'nk 8/13/2003 14:42'!
newState: aStateName
	"Drive state handlers to accomplish a static state transition.
	Answers nil for convenience: you can say:
		^self newState: 'whatever'
	in a handler method.
	A static state transition is one in which the source and target of the transition do not change at run time.
	See also #newDynamicState:"
	"Q_TRAN()"
	self transitionDynamicallyTo: (self state: aStateName).
	^nil! !

!QHsm methodsFor: 'printing' stamp: 'nk 8/14/2003 08:27'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $[; nextPutAll: myState stateName; nextPut: $]! !

!QHsm methodsFor: 'private' stamp: 'nk 2/17/2004 21:20'!
selectorFor: type in: stateName
	"Answer a selector that I understand for handling an event of type 'type', or nil."

	| selector |
	"first try full selector"
	selector _ self fullSelectorFor: type in: stateName.
	Symbol hasInterned: selector ifTrue: [ :sym |
		(self respondsTo: sym)
			ifTrue: [ ^sym ]].

	"then try short selector"
	selector _ self shortSelectorFor: type in: stateName.
	Symbol hasInterned: selector ifTrue: [ :sym |
		(self respondsTo: sym)
			ifTrue: [ ^sym ]].
	
	"otherwise, I don't understand it."
	^nil
! !

!QHsm methodsFor: 'private' stamp: 'nk 8/14/2003 18:57'!
shortSelectorFor: type in: stateName
	| fullSelector |
	fullSelector := String new: 6 + stateName size.	"stateSelector:"
	fullSelector
		replaceFrom: 1
			to: 5
			with: 'state'
			startingAt: 1;
		replaceFrom: 6
			to: 5 + stateName size
			with: stateName
			startingAt: 1;
		at: fullSelector size put: $:.
	^fullSelector! !

!QHsm methodsFor: 'reflection' stamp: 'nk 8/14/2003 22:23'!
stateHierarchy
	"Answer a String that represents my state hierarchy."

	| specific general possibleStates possibleEvents superstates |
	specific := Set 
				withAll: (self class allSelectorsUnderstood select: 
							[:ea | 
							('handle*In*' match: ea) 
								and: [(ea at: 7) isUppercase and: [(ea beginsWith: 'handleIn') not]]]).
	general := Set 
				withAll: (self class allSelectorsUnderstood select: 
							[:ea | 
							('state*' match: ea) 
								and: [(ea at: 6) isUppercase and: [(specific includes: ea) not]]]).
	general removeAll: #(#stateTop: #stateHierarchy).
	possibleStates := Set new.
	possibleEvents := Dictionary new.
	specific do: 
			[:ea | 
			| i s e |
			i := ea indexOfSubCollection: 'In' startingAt: 8.
			s := ea copyFrom: i + 2 to: ea size - 1.
			possibleStates add: s.
			e := ea copyFrom: 7 to: i - 1.
			(possibleEvents at: s ifAbsentPut: [Set new]) add: e].
	general do: 
			[:ea | 
			| s |
			s := ea copyFrom: 6 to: ea size - 1.
			possibleStates add: s].
	superstates := Dictionary new.
	possibleStates 
		do: [:s | superstates at: s put: (self state: s) superstate stateName].
	^String streamContents: 
			[:s | 
			self 
				hierarchyFrom: superstates
				andEvents: possibleEvents
				into: s
				startingAt: #Top
				level: 0]! !

!QHsm methodsFor: 'state handlers' stamp: 'nk 8/14/2003 18:58'!
stateTop: anEvent 
	"This should not be overridden by subclasses."

	(self class reservedEventTypes includes: anEvent eventType) ifTrue: [^nil].
	^self handleUnhandledEvent: anEvent! !

!QHsm methodsFor: 'private' stamp: 'nk 8/8/2003 09:56'!
state: stateOrName
	"Construct a new state for me"
	^stateOrName isQState
		ifTrue: [ stateOrName ]
		ifFalse: [ QState fsm: self name: stateOrName]! !

!QHsm methodsFor: 'accessing' stamp: 'nk 8/12/2003 12:56'!
top
	"Answer my top state"
	^self state: #Top! !

!QHsm methodsFor: 'private' stamp: 'nk 9/29/2003 16:34'!
transitionDynamicallyTo: target
	"First execute the exit actions from myState to the least-common ancestor of myState and target.
	Then execute the entry actions from the LCA to target.
	Any actions associated with the transition itself should already be done in the source state.
	See PSCC++ listing 4.10"
	| entry p q s  |
	self assert: [ target ~= self top ].	"cannot target 'top' state."
	entry _ OrderedCollection new.

	"First, exit all the nested states between myState and mySource."
	s _ myState.
	[ s ~= mySource ] whileTrue: [
		self assert: [ s notNil ].
		s _ s exit ifNil: [ s superstate ].
	].

	"Now check all seven of the possible source/target state combinations"
	entry add: target.

	"(a) check mySource == target (transition to self)"
	mySource = target ifTrue: [
		mySource exit.
		^self enter: target via: entry.
	].

	"(b) check mySource == target superstate"
	p _ target superstate.
	mySource = p ifTrue: [ ^self enter: target via: entry ].	"no exit action"
	
	self assert: [ mySource notNil ].

	"(c) check mySource superstate == target superstate (most common)"
	q _ mySource superstate.
	q = p ifTrue: [
		mySource exit.
		^self enter: target via: entry.
	].

	"(d) check mySource superstate == target"
	q = target ifTrue: [
		mySource exit.
		entry removeLast.	"do not enter the LCA"
		^self enter: target via: entry.
	].

	"(e) check rest of mySource = target super super [...] hierarchy"
	entry addLast: p.
	s _ p superstate.
	[ s notNil ] whileTrue: [
		mySource = s ifTrue: [ ^self enter: target via: entry ].
		entry addLast: s.
		s _ s superstate.
	].

	"otherwise we're definitely exiting mySource."
	mySource exit.

	"(f) check rest of mySource super = target super super [...] hierarchy"
	entry size to: 1 do: [ :lca |
		(q = (entry at: lca)) ifTrue: [
			^self enter: target via: (entry copyFrom: 1 to: lca - 1).	"do not enter the LCA"
		]
	].

	"(g) check each mySource super super [...] for each target super [...]"
	s _ q.
	[ s notNil ] whileTrue: [
		entry size to: 1 by: -1 do: [ :lca |
			s = (entry at: lca) ifTrue: [
				^self enter: target via: (entry copyFrom: 1 to: lca - 1).	"do not enter the LCA"
			]
		].
		s exit.
		s _ s superstate.
	].

	self assert: [ false ].			"malformed FSM"! !

Object subclass: #QState
	instanceVariableNames: 'fsm stateName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FSM-Base'!

!QState class methodsFor: 'instance creation' stamp: 'nk 8/7/2003 16:32'!
fsm: fsm name: aString 
	^self new fsm: fsm name: aString! !

!QState methodsFor: 'private' stamp: 'nk 2/17/2004 21:13'!
dispatchEvent: anEvent selector: selector
	| retval |
	retval _ fsm dispatchEvent: anEvent selector: selector.
	self assert: [ retval isNil or: [ retval isQState ]].
	^retval! !

!QState methodsFor: 'dispatching' stamp: 'nk 8/12/2003 13:03'!
enter
	"Trigger the reserved #entry signal.
	Answer nil if handled, otherwise a superstate."
	^self trigger: #entry! !

!QState methodsFor: 'dispatching' stamp: 'nk 8/12/2003 13:03'!
exit
	"Trigger the reserved #exit signal.
	Answer nil if handled, otherwise a superstate."
	^self trigger: #exit! !

!QState methodsFor: 'accessing' stamp: 'nk 8/8/2003 07:02'!
fsm
	^fsm! !

!QState methodsFor: 'initialization' stamp: 'nk 8/8/2003 07:28'!
fsm: anFSM name: aStateName 
	fsm := anFSM.
	stateName := aStateName capitalized.
! !

!QState methodsFor: 'comparing' stamp: 'nk 8/8/2003 08:43'!
hash
	^stateName hash bitXor: fsm hash! !

!QState methodsFor: 'dispatching' stamp: 'nk 8/12/2003 13:03'!
init
	"Trigger the reserved #init signal, which should be handled (if at all) by sending #newInitialState: to set the proper initial substate.
	Answer nil if handled, otherwise a superstate."
	^self trigger: #init! !

!QState methodsFor: 'testing' stamp: 'nk 8/8/2003 08:54'!
isQState
	^true! !

!QState methodsFor: 'printing' stamp: 'nk 8/12/2003 14:30'!
printOn: aStream
	aStream nextPutAll: 'QState(';
		nextPutAll: stateName;
		nextPut: $)! !

!QState methodsFor: 'accessing' stamp: 'nk 8/8/2003 07:01'!
stateName
	^stateName! !

!QState methodsFor: 'accessing' stamp: 'nk 8/8/2003 07:01'!
stateName: anObject
	stateName := anObject! !

!QState methodsFor: 'accessing' stamp: 'nk 8/11/2003 22:18'!
superstate
	"Answer my superstate.
	Default is to return the fsm's top state."
	| superstate |
	superstate _ self trigger: #empty.
	^superstate isQState
		ifTrue: [ superstate ]
		ifFalse: [ superstate _ fsm top.
			self = superstate ifTrue: [ nil ] ifFalse: [ superstate ]]! !

!QState methodsFor: 'dispatching' stamp: 'nk 2/17/2004 21:49'!
trigger: anEvent
	"Make my FSM respond to anEvent.
	First try a full selector of the form #handleEventInState:,
	then a short selector of the form #handleState:"
	| selector type |
	type _ anEvent eventType.
	selector _ fsm selectorFor: type in: stateName.
	^selector
		ifNotNil: [ self dispatchEvent: anEvent selector: selector ]
		ifNil: [ self error: 'no handler for ', type, ' in state ', stateName.
			nil ]! !

!QState methodsFor: 'comparing' stamp: 'nk 8/8/2003 08:57'!
= aStateOrString
	"Answer whether my state name matches aStateOrString,
	and if aStateOrString is a QState, also if I have the same fsm as aStateOrString."
	
	^aStateOrString isQState
		ifTrue: [ stateName = aStateOrString stateName
			and: [ fsm == aStateOrString fsm ]]
		ifFalse: [ stateName = aStateOrString ]! !

!MorphicEvent methodsFor: '*FSM-events' stamp: 'nk 8/8/2003 07:13'!
eventType
	"Return a symbol indicating the type of this event."
	^self type! !
